/** \brief boundary grid function selecting boundary conditions 
 * 0 means Neumann
 * 1 means Dirichlet
 */
 /* OLD:
template<typename GV>
class BCType : public Dune::PDELab::BoundaryGridFunctionBase<
       Dune::PDELab::BoundaryGridFunctionTraits<GV,int,1,
       Dune::FieldVector<int,1> >,BCType<GV> >
{
  const GV& gv;
public:
  typedef Dune::PDELab::BoundaryGridFunctionTraits<
          GV,int,1,Dune::FieldVector<int,1> > Traits;

  //! construct from grid view
  BCType (const GV& gv_) : gv(gv_) {}

  //! return bc type at point on intersection
  template<typename I>
  inline void evaluate (I& i, const typename Traits::DomainType& xlocal,
                        typename Traits::RangeType& y) const

	// i steht für intersection ? - könnte entity von codim 1 sein ?
  {  
    Dune::FieldVector<typename GV::Grid::ctype,GV::dimension> 
      x = i.geometry().global(xlocal);
    y = 1; // default is Dirichlet
    //return;
    //if (x[0]>1.0-1e-6)
    //  y = 0; // Neumann
    return;
  }

  //! get a reference to the grid view
  inline const GV& getGridView () {return gv;}
};
*/

/* New,Example:

| class BCType : public Dune::PDELab::DirichletConstraintsParameters
| {
| public:
|
|   template<typename I>
|   bool isDirichlet
|   ( const I & intersection,
|     const Dune::FieldVector<typename I::ctype, I::dimension-1> &coord ) const
|   {
|     Dune::FieldVector<typename I::ctype, I::dimension>
|       xg = intersection.geometry().global( coord );
|
|     if ( xg[1]<1E-6 || xg[1]>1.0-1E-6 )
|       return false; // not Dirichlet
|     else
|       return true;  // Dirichlet b.c. on all other boundaries
|   }
| };
*/

class BCType : public Dune::PDELab::DirichletConstraintsParameters
{
public:
	template<typename I>
	bool isDirichlet(const I & intersection, const Dune::FieldVector<typename I::ctype, I::dimension-1> &coord ) const
	{
  	Dune::FieldVector<typename I::ctype, I::dimension>
    xg = intersection.geometry().global(coord);
//  if ( xg[1]<1E-6 || xg[1]>1.0-1E-6 )
//	std::cout << "ISDirirchlet is called " << std::endl;
//	IN PARALLEL CASE VERY IMPORTANT TO USE RIGHT BOUNDARY, since this is asked on local process !!
//  WAS once forgotten and took long tome to find error !!!
    if (xg[0]>9.9999 || xg[0]<-9.9999 || xg[1]>9.9999 || xg[1]<-9.9999 || xg[2]>9.9999 || xg[2]<-9.9999)
      return true; // Dirichlet
    //TEST:return always false 		return false; 
    else
    	return false;  // not Dirichlet 
  }
		//Dune::FieldVector<typename I::ctype, I::dimension> xg = intersection.geometry().global( coord );
		//if (x[0]>1.0-1e-6)
};

class FalseType : public Dune::PDELab::DirichletConstraintsParameters
{
public:
	template<typename I>
	bool isDirichlet(const I & intersection, const Dune::FieldVector<typename I::ctype, I::dimension-1> &coord ) const
	{
	 	/*
	 	Dune::FieldVector<typename I::ctype, I::dimension> xg = intersection.geometry().global(coord);
    if (xg[0]>9.9999 || xg[0]<-9.9999 || xg[1]>9.9999 || xg[1]<-9.9999 || xg[2]>9.9999 || xg[2]<-9.9999)
      return false; // Dirichlet boundary for this grid
    else  
    	return true;  // not Dirichlet but on boundary - must be ghost 
    */ 
    return false;	
  }	
};
